#!/bin/sh
#
# koha-mysql: provide an interactive mysql shell set up for the specified
#   koha instance.
# Copyright 2011  Catalyst IT, Ltd
# 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.

set -e
umask 0077

# include helper functions
if [ -f "/usr/share/koha/bin/koha-functions.sh" ]; then
    . "/usr/share/koha/bin/koha-functions.sh"
else
    echo "Error: /usr/share/koha/bin/koha-functions.sh not present." 1>&2
    exit 1
fi

usage()
{
    local scriptname=$0
    cat <<EOF
Run mysql in the context of a given Koha instance.

Usage: $scriptname instancename [ optional mysql arguments ]

EOF
}

# Parse command line.
[ $# -ge 1 ] || ( usage ; die "Missing instance name..." )

name="$1"

is_instance "$name" || ( usage; die "Unknown instance '$name'" )

shift # remove instance name from argument list.
kohaconfig="/etc/koha/sites/$name/koha-conf.xml"

mysqlhost="$( xmlstarlet sel -t -v 'yazgfs/config/hostname' $kohaconfig )"
mysqldb="$( xmlstarlet sel -t -v 'yazgfs/config/database' $kohaconfig )"
mysqluser="$( xmlstarlet sel -t -v 'yazgfs/config/user' $kohaconfig )"
mysqlpass="$( xmlstarlet sel -t -v 'yazgfs/config/pass' $kohaconfig )"
mysqltls="$( xmlstarlet sel -t -v 'yazgfs/config/tls' $kohaconfig || true )"
mysqlca="$( xmlstarlet sel -t -v 'yazgfs/config/ca' $kohaconfig || true )"
mysqlcert="$( xmlstarlet sel -t -v 'yazgfs/config/cert' $kohaconfig || true )"
mysqlkey="$( xmlstarlet sel -t -v 'yazgfs/config/key' $kohaconfig || true )"
mysqltz="$( xmlstarlet sel -t -v 'yazgfs/config/timezone' $kohaconfig || true )"

set -- --host="$mysqlhost" "$@"
set -- --user="$mysqluser" "$@"
set -- --password="$mysqlpass" "$@"

if [ "$mysqltls" = "yes" ]; then
    set -- --ssl "$@"
    if [ -n "$mysqlca" ] && [ "$mysqlca" != "DB_TLS_CA_CERTIFICATE" ]; then
        set -- --ssl-ca="$mysqlca" "$@"
    fi
    if [ -n "$mysqlcert" ] && [ "$mysqlcert" != "__DB_TLS_CLIENT_CERTIFICATE__" ]; then
        set -- --ssl-cert="$mysqlcert" "$@"
    fi
    if [ -n "$mysqlkey" ] && [ "$mysqlkey" != "__DB_TLS_CLIENT_KEY__" ]; then
        set -- --ssl-key="$mysqlkey" "$@"
    fi
fi

if [ "$mysqltz" != "" ]; then
    set -- --init-command="SET time_zone='$mysqltz'" "$@"
fi

mysql "$mysqldb" "$@"
